package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.service.dao.mapper.StaffDepartmentRelatedMapper;
import com.gic.haoban.manage.service.entity.TabHaobanStaffDepartmentRelated;
import com.gic.haoban.manage.service.service.StaffDepartmentRelatedService;

@Service
public class StaffDepartmentRelatedServiceImpl implements StaffDepartmentRelatedService {
	
	@Autowired
	private StaffDepartmentRelatedMapper mapper;

	@Override
	public List<TabHaobanStaffDepartmentRelated> listByDepartmentId(String departmentId) {
		
		return mapper.listByDepartmentId(departmentId);
	}

	@Override
	public String add(StaffDepartmentRelatedDTO related) {
		Date now = new Date();
		related.setCreateTime(now);
		related.setUpdateTime(now);
		related.setStatusFlag(1);
		related.setStaffDepartmentRelatedId(StringUtil.randomUUID());
		TabHaobanStaffDepartmentRelated tab = EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, related);
		mapper.insert(tab);
		return related.getStaffDepartmentRelatedId();
	}

	@Override
	public List<TabHaobanStaffDepartmentRelated> listStaffDepartmentByStaffId(String staffId) {
		return mapper.listStaffDepartmentByStaffId(staffId);
	}

	@Override
	public StaffDepartmentRelatedDTO selectById(String staffDepartmentStaffRelatedId) {
		
		return EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, mapper.selectByPrimaryKey(staffDepartmentStaffRelatedId));
	}

	@Override
	public void del(StaffDepartmentRelatedDTO related) {
		TabHaobanStaffDepartmentRelated tab  = EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, related);
		tab.setStatusFlag(0);
		tab.setUpdateTime(new Date());
		mapper.updateByPrimaryKeySelective(tab);
		
	}

	@Override
	public void delByUserid(String userid) {

	}

	@Override
	public TabHaobanStaffDepartmentRelated getDepartmentIdAndStaffId(String departmentId, String staffId) {
		return mapper.getDepartmentIdAndStaffId(departmentId,staffId);
	}

	@Override
	public int countByDepartmentId(String departmentId) {
		
		return mapper.countByDepartmentId(departmentId);
	}

	@Override
	public List<TabHaobanStaffDepartmentRelated> listByDepartmentIdByKeyword(String departmentId, String keyword) {
		return mapper.listByDepartmentIdByKeyword(departmentId,keyword);
	}


}
