package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.WxEnterpriseDTO;
import com.gic.haoban.manage.service.dao.mapper.WxEnterpriseMapper;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.gic.haoban.manage.service.service.WxEnterpriseService;

@Service
public class WxEnterpriseServiceImpl implements WxEnterpriseService {
	@Autowired
	WxEnterpriseMapper mapper;

	@Override
	public String add(WxEnterpriseDTO wxDTO) {
		Date now = new Date();
		wxDTO.setWxEnterpriseId(StringUtil.randomUUID());
		wxDTO.setCreateTime(now);
		wxDTO.setUpdateTime(now);
		TabHaobanWxEnterprise tabHaobanWxEnterprise = EntityUtil.changeEntityByJSON(TabHaobanWxEnterprise.class, wxDTO);
		tabHaobanWxEnterprise.setStatusFlag(1);
		mapper.insertSelective(tabHaobanWxEnterprise);
		return wxDTO.getWxEnterpriseId();
		
	}

	@Override
	public WxEnterpriseDTO selectById(String wxEnterpriseId) {
		return EntityUtil.changeEntityByJSON(WxEnterpriseDTO.class, mapper.selectByPrimaryKey(wxEnterpriseId));
	}

	@Override
	public TabHaobanWxEnterprise getEnterpriseBycorpId(String corpId) {
		List<TabHaobanWxEnterprise> list = this.mapper.listBycorpId(corpId);
		if(CollectionUtils.isNotEmpty(list)){
			return list.get(0);
		}
		return null;
	}

	@Override
	public TabHaobanWxEnterprise getDelEnterpriseBycorpId(String corpId) {
		List<TabHaobanWxEnterprise> list = this.mapper.listDelBycorpId(corpId);
		if(CollectionUtils.isNotEmpty(list)){
			return list.get(0);
		}
		return null;
	}

	@Override
	public void update(WxEnterpriseDTO enterpriseDTO) {
		enterpriseDTO.setUpdateTime(new Date());
		mapper.updateByPrimaryKeySelective(EntityUtil.changeEntityByJSON(TabHaobanWxEnterprise.class, enterpriseDTO));
	}

	@Override
	public int delete(String wxEnterpriseId) {
		TabHaobanWxEnterprise enterprise = new TabHaobanWxEnterprise();
		enterprise.setWxEnterpriseId(wxEnterpriseId);
		enterprise.setStatusFlag(0);
		return this.mapper.updateByPrimaryKeySelective(enterprise);
	}

}
