package com.gic.haoban.manage.service.service.out.impl;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.ApplicationSettingDTO;
import com.gic.haoban.manage.api.service.ApplicationSettingApiService;
import com.gic.haoban.manage.service.dao.mapper.ApplicationSettingMapper;
import com.gic.haoban.manage.service.entity.TabHaobanApplicationSetting;

/**
 * Created by tgs on 2020/2/9.
 */
@Service
public class ApplicationSettingApiServiceImpl implements ApplicationSettingApiService{
	@Autowired
	private ApplicationSettingMapper applicationSettingMapper;
	@Override
	public void saveSetting(String wxEnterpriseId, String applicationId,
			int openFlag) {
		TabHaobanApplicationSetting tab = applicationSettingMapper.findSetting(wxEnterpriseId, applicationId);		
		if(tab == null){
			tab = new TabHaobanApplicationSetting();
			tab.setApplicationId(applicationId);
			tab.setCreateTime(new Date());
			tab.setOpenFlag(openFlag);
			tab.setSettingId(UuidUtil.randomUUID());
			tab.setStatusFlag(1);
			tab.setUpdateTime(new Date());
			tab.setWxEnterpriseId(wxEnterpriseId);
			applicationSettingMapper.insert(tab);
		}else{
			applicationSettingMapper.saveSetting(wxEnterpriseId, applicationId, openFlag);
		}
	}

	@Override
	public ApplicationSettingDTO findSettingByWxEnterpriseIdAndApplicationId(
			String wxEnterpriseId, String applicationId) {
		TabHaobanApplicationSetting tab = applicationSettingMapper.findSetting(wxEnterpriseId, applicationId);		
		if(tab == null){
			return null;
		}
		ApplicationSettingDTO dto = EntityUtil.changeEntity(ApplicationSettingDTO.class, tab);
		return dto;
	}
}
