package com.gic.haoban.manage.service.service.out.impl;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.wechat.api.service.qywx.QywxUserApiService;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterpriseRelated;
import com.gic.haoban.manage.service.service.MemberUnionRelatedService;
import com.gic.haoban.manage.service.service.StaffService;
import com.gic.haoban.manage.service.service.WxEnterpriseRelatedService;
import com.gic.haoban.manage.service.service.WxEnterpriseService;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberService;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService{
	private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
	@Autowired
	private MemberUnionRelatedService memberUnionRelatedService;
	@Autowired
	private StaffService staffService;
	@Autowired
	private QywxUserApiService qywxUserApiService;
	@Autowired
	private com.gic.enterprise.api.service.StoreGroupService gicDepartmentService;
	@Autowired
	private MemberService memberService;
	@Autowired
	private WxEnterpriseRelatedService wxEnterpriseRelatedService;
	@Autowired
	private WxEnterpriseService wxEnterpriseService;

	@Override
	public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		log.info("【查询会员】wxUserId={},unionid={}",staff.getWxUserId(),unionid);
		return memberUnionRelatedService.getByUnionId(staff.getWxUserId(),unionid);
	}
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		log.info("【新增外部联系人回调】dto={}",JSON.toJSONString(dto));
		String corpId = dto.getCorpid();
		TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(corpId);
		if(wxEnterprise == null){
			return "";
		}
		List<TabHaobanWxEnterpriseRelated> list = wxEnterpriseRelatedService.getByWxEnterpriseId(wxEnterprise.getWxEnterpriseId());
		
		String unionIdJson = qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
		log.info("【新增外部联系人回调】unionIdJson={}",JSON.toJSONString(unionIdJson));
		String unionId = "";
		if(StringUtils.isNotBlank(unionIdJson)){
			JSONObject jo = JSON.parseObject(unionIdJson);
			unionId = jo.getString("unionid");
		}
		
		MemberDTO member = null;
		for (TabHaobanWxEnterpriseRelated tabHaobanWxEnterpriseRelated : list) {
			 member = memberService.getMemberByUnionid(unionId, tabHaobanWxEnterpriseRelated.getEnterpriseId());
			 if(member != null){
				 break;
			 }
		}
		if(member != null){
			dto.setMemberId(member.getMemberId());
		}
		dto.setWxEnterpriseId(wxEnterprise.getWxEnterpriseId());
		dto.setUnionid(unionId);
		this.getExternalUserUnionid(dto);
		return memberUnionRelatedService.addMemberUnionidRelated(dto);
	}
	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		this.getExternalUserUnionid(dto);
		memberUnionRelatedService.delMemberUnionidRelated(dto);
		
	}

	private void getExternalUserUnionid(MemberUnionidRelatedDTO dto){
		String externalUseridInfo = this.qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
		if(StringUtils.isNotBlank(externalUseridInfo)){
			JSONObject jsonObject = JSON.parseObject(externalUseridInfo);
			dto.setUnionid(jsonObject.getString("unionid"));
		}
	}
	@Override
	public MemberUnionidRelatedDTO getByMemberId(String staffId, String memberId) {
		
		return null;
	}
	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
		List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId,wxEnterpriseId);
		return list;
	}
}
