package com.gic.haoban.manage.web.controller;

import java.util.List;

import com.alibaba.fastjson.JSON;
import com.ctrip.framework.apollo.spring.annotation.ApolloConfig;
import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.GlobalVar;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.service.ApplicationSettingApiService;
import com.gic.haoban.manage.api.service.AuditApiService;
import com.gic.haoban.manage.api.service.AuditSettingApiService;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.WxApplicationApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.web.anno.IgnoreLogin;
import com.gic.haoban.manage.web.auth.AuthRequestUtil;
import com.gic.haoban.manage.web.config.Config;
import com.gic.haoban.manage.web.vo.LoginVO;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;

import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.service.ApplicationApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
@RequestMapping("/audit")
public class AuditController extends WebBaseController{
	private static final Logger log = LogManager.getLogger(AuditController.class);
	
	@Autowired
	private AuditSettingApiService auditSettingApiService;
	@Autowired
	private AuditApiService auditApiService;
	//设置保存
	@RequestMapping("open-or-close")
	public HaobanResponse openOrClose(String wxEnterpriseId,Integer auditFlag) {
		if(StringUtils.isAnyBlank(wxEnterpriseId)){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		if(auditFlag == null){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		auditSettingApiService.saveSetting(wxEnterpriseId, auditFlag);
		return resultResponse(HaoBanErrCode.ERR_1);
	}
	//设置查看
	@RequestMapping("find-setting")
	public HaobanResponse findSetting(String wxEnterpriseId ) {
		if(StringUtils.isAnyBlank(wxEnterpriseId)){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		auditSettingApiService.findSettingByWxEnterpriseId(wxEnterpriseId);
		return resultResponse(HaoBanErrCode.ERR_1);
	}
	//分页查找
	@RequestMapping("find-page")
	public HaobanResponse findPage(String wxEnterpriseId,String enterpriseId,String search,BasePageInfo pageInfo ,Integer auditType,Integer auditStatus ) {
		if(auditStatus == null){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		Page<AuditDTO> page = auditApiService.page(auditType, search, wxEnterpriseId,enterpriseId, auditStatus, pageInfo);
		return resultResponse(HaoBanErrCode.ERR_1,page);
	}
	//审核拒绝
	@RequestMapping("refuse")
	public HaobanResponse refuse(String auditId,String auditReason ) {
		if(StringUtils.isAnyBlank(auditId,auditReason)){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		auditApiService.refuse(auditId, auditReason);
		return resultResponse(HaoBanErrCode.ERR_1);
	}
	//审核同意
	@RequestMapping("audit")
	public HaobanResponse audit(String auditId ) {
		if(StringUtils.isAnyBlank(auditId)){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		auditApiService.audit(auditId);
		return resultResponse(HaoBanErrCode.ERR_1);
	}
}
